/* 
 * $Id: Notify.java,v 1.2 1996/01/19 02:06:27 iansmith Exp $
 * $Author: iansmith $
 * $Log: Notify.java,v $
 * Revision 1.2  1996/01/19  02:06:27  iansmith
 * Fixed a bug in my RCS comments at the top.
 *
 */

package GIT.GVU.IMAP.Tests;
import GIT.GVU.IMAP.*;
import java.lang.*;

/**
 * This is a little demo class to show you how to implement callbacks.
 * 
 * @version $Id: Notify.java,v 1.2 1996/01/19 02:06:27 iansmith Exp $
 * @author Ian Smith
 */

public class Notify implements AsynchronousAction {
  /** 
   * This is the function that gets called when AsynchronousAction objects
   * end up getting used. Note that we use the same object for all of the 
   * actions, but you can make different classes if you want.
   * 
   * @param String msg String which is what message we just got
   * @param Object o parameter specific to the type of message
   */
  public void run(String msg, Object o) {
    String byeMessage;
    Integer n;
    /* test for possible BYE */
    if (msg.equalsIgnoreCase("BYE")==true)  {
      /* its a bye , convert the argument */
      byeMessage=(String)o;
      /*print something to tell the user what happened */
      System.out.println("Server closing connection! Reason: " + byeMessage);
      return;
    }
    /* test for possible EXPUNGE */
    if (msg.equalsIgnoreCase("EXPUNGE")==true) {
      /* convert parameter */
      n=(Integer)o;
      /* Note: The fact that we are giving the user the message number here is */
      /* probably kind of confusing due to the renumbering scheme used by */
      /* IMAP.... ah well */
      System.out.println("IMAP Server just permanently deleted message #" + n);
      return;
    }
    /* possible RECENT */
    if (msg.equalsIgnoreCase("RECENT")==true) {
      /* convert to Integer */
      n=(Integer)o;
      /* now if n is zero, this is just an information message from the server */
      /* when select a mailbox or we do an expunge */
      if (n.intValue()==0) {
	/* don't bother */
	return;
      }
      /* we need to tell the main object what is going on ... so shove the number */
      /* of new mail messages into the variable its looking at when it prints a */
      /* prompt */
      Driver.newMailCount=n.intValue();
      return;
    }
    /* this shouldn't happen */
    /* if anything else, just warn the user that we are confused */
    System.out.println("WARNING: Unable to deal with an AsynchronousAction on message " + msg);
  }
}
